package chap2;

import java.lang.annotation.Retention;
import java.lang.annotation.ElementType;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.annotation.Documented;;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@interface Debug {}

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Documented
@interface Version { double value(); }

@Version(0.1)
public class AnnotationSample2 {

	@Debug
	public void disp() {
	}
	public static void main(String[] args) throws SecurityException, NoSuchMethodException {

		// Versionアノテーションを取得
		Version v = AnnotationSample2.class.getAnnotation(Version.class);
		// バージョン表示
		System.out.println( v.value() );

		// Debugアノテーションを取得
		Debug d = AnnotationSample2.class.getMethod("disp").getAnnotation(Debug.class);
		if ( d != null ) {
			System.out.println( "debug!" );
		}

	}
}
