package chap3;

import java.util.Calendar;
import java.util.logging.*;

//ログレコードにある情報を利用することにより、独自のフォーマッタを作り、それを使用してログを取ります。
public class MyFormatterSample{
	public static void main(String[] args){
		Logger logger = Logger.getLogger("myformatter.logging");
		try{
			FileHandler handler = new FileHandler("fmtlog.log");
			Formatter formatter = new MyFormatter();
			//フォーマッタに作成したフォーマッタを指定
			handler.setFormatter(formatter);
			//ログの出力先にファイルを指定
			logger.addHandler(handler);
		}
		catch(java.io.IOException e){
			e.printStackTrace();
		}
		logger.setLevel(Level.ALL);
		logger.info("INFOレベルのログ");
		logger.config("CONFIGレベルのログ");
		logger.warning("WARNINGレベルのログ");
	}
}
//Formatterクラスを継承して独自のフォーマッタを作成
//ここでは日付／時刻と発行ロガー名、ログレベル、メッセージ
//を文字列として格納するフォーマッタを作成している
class MyFormatter extends Formatter{
	public String format(LogRecord recode){
		StringBuffer buf = new StringBuffer();
		Calendar cal = Calendar.getInstance();
		cal.setTimeInMillis(recode.getMillis());
		buf.append(cal.get(Calendar.YEAR) + "/" + (cal.get(Calendar.MONTH) + 1) + "/" + cal.get(Calendar.DATE) + " " + cal.get(Calendar.HOUR_OF_DAY) + ":" + cal.get(Calendar.MINUTE) + ":" + cal.get(Calendar.SECOND));
		buf.append("\r\n");
		buf.append("発行ロガー名:" + recode.getLoggerName());
		buf.append("\r\n");
		buf.append("ログレベル:" + recode.getLevel().getName());
		buf.append("\r\n");
		buf.append("メッセージ:" + recode.getMessage());
		buf.append("\r\n\r\n");
		return buf.toString();
	}
}
