package chap3;
import java.util.logging.*;

//ロガーの追加と削除を行い、各ログレベルのログをコンソールとファイルに出力します。
public class OutLog{
	public static void main(String[] args){
		Logger logger = Logger.getLogger("logstatic.logging");
		try{
			FileHandler handler = new FileHandler("staticlog.log");
			Formatter formatter = new SimpleFormatter();
			//ログのフォーマットを設定
			handler.setFormatter(formatter);
			//ログを取るハンドラとしてファイルを追加
			logger.addHandler(handler);
			//ロガーのログレベルをCONFIGに設定
			logger.setLevel(Level.CONFIG);
			//ログの出力
			logger.warning("静的WARNINGログの出力");
			logger.log(Level.CONFIG, "動的CONFIGログ出力");
			logger.log(Level.INFO, "動的INFOログ出力");
			logger.removeHandler(handler);
			logger.log(Level.SEVERE, "動的SEVERログ出力");
		}
		catch(java.io.IOException e){
			System.out.println("ファイルハンドラの例外");
		}
	}
}
