package chap5;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.Date;

public class CNFileReadWriteSample {
	public static void main(String[] args) {
		try {
			// 15MBほどのファイルを作成します
		    File f= new File("chap5/data/cnOri.txt");
			BufferedWriter tmp = new BufferedWriter(new FileWriter(f));
		    for (int i=0;i<500000;i++){
		    	tmp.write(new Date().toString());
		    	tmp.newLine();
		    }
		    tmp.close();

			long s = new Date().getTime();

			// cnOri.txtの内容をcnCpy.txtにコピー
			FileChannel in = new FileInputStream(f).getChannel();
			FileChannel out =
				new FileOutputStream("chap5/data/cnCpy.txt").getChannel();

			ByteBuffer bf = ByteBuffer.allocateDirect((int) in.size());
			bf.clear();
			in.read(bf);
			bf.flip();
			out.write(bf);
			in.close();
			out.close();
			System.out.println(new Date().getTime() - s+"ミリ秒(allocateDirect)");

			// 15MBほどのファイルを作成します
		    File f2= new File("chap5/data/cnOri2.txt");
			tmp = new BufferedWriter(new FileWriter(f2));
		    for (int i=0;i<500000;i++){
		    	tmp.write(new Date().toString());
		    	tmp.newLine();
		    }
		    tmp.close();

			s = new Date().getTime();
			FileChannel in2 = new FileInputStream(f).getChannel();
			FileChannel out2 =
				new FileOutputStream("chap5/data/cnCpy2.txt").getChannel();

			// cnOri.txtの内容をcnCpy.txtにコピー
			in2.transferTo(0, in2.size(), out2);
			in2.close();
			out2.close();
			System.out.println(new Date().getTime() - s+"ミリ秒(transferTo)");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
