package chap5;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;

public class InputStreamRWSample2 {
	public static void main(String[] args) {
		try {
			File f = new File("chap5/data/isfile2.txt");

			Charset cs = Charset.forName("SJIS");

			OutputStreamWriter out =
				new OutputStreamWriter(new FileOutputStream(f), cs.newEncoder());
			out.write("東京・大阪");
		    out.close();

			InputStreamReader in =
				new InputStreamReader(new FileInputStream(f), cs.newDecoder());

			File f2 = new File("chap5/data/isfile3.txt");
			OutputStreamWriter out2 =
				new OutputStreamWriter(new FileOutputStream(f2), "UTF8");
			
			while( in.ready() ) out2.write(in.read());
			in.close();
			out2.close();

			InputStreamReader in2 =
				new InputStreamReader(new FileInputStream(f2), "UTF8");

			while( in2.ready() ) System.out.printf("%X ",in2.read());
			in2.close();
		}
		catch (IOException e) {
			System.out.println(e);
		}
	}

}
