package chap6;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

public class URLGetStreamSample2 {

	// ストリームのデータを表示
	static void view( InputStream is) throws IOException {
		BufferedReader in =
			new BufferedReader(
					new InputStreamReader(is));
		while (in.ready()) {
			System.out.println(in.readLine());
		}
		in.close();
	}

	public static void main(String[] args) throws Exception {

		URL url = new URL("http://www.google.co.jp/xxx");
		URLConnection con = url.openConnection();
		try {
			// コンテンツ表示
			view(con.getInputStream());
		}
		catch (IOException e) {
			// 	エラー（404エラーなど）発生
			try {
				System.out.println("エラー発生");
				view(((HttpURLConnection)con).getErrorStream());
			}
			catch(IOException ex) {
				// エラー情報なし
			}
		}
	}
}