package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Hashtable;
import java.util.Map;

public class CNSetSample {
	public static void main(String[] args) {
		// 警告、SQLのデータ型、更新可能かどうかといった情報を取得
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			Connection con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			if (con.isReadOnly()) {
				System.out.println("ReadOnly");
				con.setReadOnly(false);
			}

			System.out.println("warining : " + con.getWarnings());
			con.clearWarnings();

			// ユーザ定義の"SAMPLE"とStringをマッピング
			Map<String,Class<?>> map = new Hashtable<String,Class<?>>();
			map.put("SAMPLE",String.class);
			con.setTypeMap(map);

			// 現在の接続に関連したMAPの取得
			Map<String, Class<?>> map2 = con.getTypeMap();
			for ( String key : map2.keySet()) {
				System.out.println("TypeMap : " + key);
			}
			if (!con.isClosed()) {
				con.close();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
