package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;


// データベースに接続
public class DMConnectDbSample3 {
	public static void main(String[] args) {

		Connection con = null;
		PreparedStatement stmt = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			// プリペアドステートメントの登録
			stmt = con.prepareStatement("SELECT * FROM user_list WHERE id = ?");

			// 1番目のプレースホルダに、2をセットする
			stmt.setInt(1, 2);

			// プリペアドステートメントを実行し、結果の件数を表示
			System.out.println( "該当件数: "+ stmt.executeUpdate());

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}