package chap7;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;


// データベースに接続
public class DMConnectDbSample4 {
	public static void main(String[] args) {

		Connection con = null;
		Statement st = null;
		CallableStatement cs = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			// ストアドプロシージャの登録
            st = con.createStatement();
			st.executeUpdate(
					"create or replace PROCEDURE OUTPARAMNAME (mid in NUMBER, vname out VARCHAR2) as" +
					" begin"+
					" SELECT name into vname FROM user_list WHERE id=mid;"+
					" end outParamName;");

			// ストアドプロシージャの呼び出し
			cs = con.prepareCall("{call OUTPARAMNAME(?,?)}");
			cs.setInt(1, 3); // 入力パラメータの設定
			cs.registerOutParameter(2, java.sql.Types.VARCHAR); // OUTパラメータの型を指定
			cs.execute();

			// OUTパラメータを取得
		    String out = cs.getString(2);
		    System.out.println("結果: "+out);

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				if (cs!=null ) cs.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}