package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;

public class GetSample1 {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			st = con.createStatement();
			ResultSet rs = st.executeQuery("SELECT * FROM user_list");
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日（E）HH時mm分");
			while(rs.next()){
				System.out.println(rs.getInt(1) + " " + rs.getString(2) + " " + sdf.format(rs.getTimestamp("gdate")));
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
