package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class RSCursorSample {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;
		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			st = con.createStatement(
					ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
			ResultSet rs =
				st.executeQuery("SELECT * FROM user_list ORDER BY id");

			// カーソルを移動させ、そのカーソルが指す行を出力
			rs.first();
			System.out.println(
					"最初の行 " + rs.getInt("id") + " " + rs.getString("name"));
			rs.next();
			System.out.println(
					"その次 " + rs.getInt("id") + " " + rs.getString("name"));
			rs.last();
			System.out.println(
					"最後の行 " + rs.getInt("id") + " " + rs.getString("name"));
			rs.previous();
			System.out.println(
					"その前 " + rs.getInt("id") + " " + rs.getString("name"));
			rs.absolute(3);
			System.out.println(
					"前から3行目 " + rs.getInt("id") + " " + rs.getString("name"));
			rs.relative(-2);
			System.out.println(
					"その2行前 " + rs.getInt("id") + " " + rs.getString("name"));
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
