package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class RSDeleteSample {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;

		// データを挿入する領域にカーソルを移動し、新しい行を挿入
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			st = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
					ResultSet.CONCUR_UPDATABLE);

			ResultSet rs = st.executeQuery("SELECT id, name FROM user_list ORDER BY id");

			// 末尾に移動して削除
			rs.last();
			rs.deleteRow();

			// 先頭の前に移動
			rs.beforeFirst();

			// データ表示
			while (rs.next()) {
				System.out.println(
						rs.getInt("id") + " " + rs.getString("name"));
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
