package chap7;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;


// CREATE TABLE picture_list(id NUMBER(2) primary key,name VARCHAR2(20),contents BLOB);

public class RSGetSample1 {
	public static void main(String[] args) {
		Connection con = null;
		PreparedStatement pstmt = null;
		PreparedStatement pstmt2 = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			File fin = new File("chap7/sky.jpg");
			try {
				FileInputStream in = new FileInputStream(fin);
				// BLOB型の列に画像ファイルのデータを書き込む
				pstmt = con.prepareStatement("INSERT INTO picture_list(id,contents) VALUES(1,?)");
				pstmt.setBinaryStream(1, in, (int)fin.length());
				System.out.println( pstmt.executeUpdate() + "レコード追加");
				in.close();

				// BLOB型の列をselect
				pstmt2 = con.prepareStatement("SELECT contents FROM picture_list WHERE id=?");
				pstmt2.setInt(1, 1);
				ResultSet rs = pstmt2.executeQuery();
				rs.next();

				// BLOB型の列をストリームとして読み込む
				BufferedImage img = ImageIO.read( rs.getBinaryStream(1) );
				Icon icon = new ImageIcon(img);
				// 画像をダイアログで表示
				JOptionPane.showMessageDialog(null, "", "", JOptionPane.PLAIN_MESSAGE, icon );
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
			e.printStackTrace();
		}
		finally {
			try {
				if (pstmt!=null ) pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (pstmt2!=null ) pstmt2.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
