package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;

public class RSGetSample2 {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			st = con.createStatement();
			ResultSet rs = st.executeQuery("select sysdate from dual");
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日（E）HH:mm:ss");
			rs.next();
			// 日付時刻の取得
			System.out.println("getDate:\t"+sdf.format(rs.getDate(1)));
			System.out.println("getTime:\t"+sdf.format(rs.getTime(1)));
			System.out.println("getTimestamp:\t"+sdf.format(rs.getTimestamp(1)));

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
