package chap7;

import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


public class RSGetTypeSample {
	public static void main(String[] args) throws IllegalArgumentException, IllegalAccessException {
		Connection con = null;
		Statement st = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			st = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
												ResultSet.CONCUR_UPDATABLE);
			ResultSet rs = st.executeQuery("select *  from user_list");

			// 設定されたカーソルの性質をしめす定数名を表示
			Field[] f = ResultSet.class.getFields();
			for ( int i=0; i<f.length; i++) {
				if ( f[i].getInt(f[i]) == rs.getType() |
						f[i].getInt(f[i]) == rs.getConcurrency()) {
					System.out.println( f[i].getName());
				}
			}

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
