package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

public class RSSetGetInfoSample {
	public static void main(String[] args) {
		// ResultSetオブジェクトに関する情報を設定／取得
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			Connection con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");
			Statement st = con.createStatement(
					ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
			ResultSet rs = st.executeQuery("SELECT id,name FROM user_list WHERE id>10 ORDER BY id");
			System.out.println("警告：" + rs.getWarnings());
			rs.clearWarnings();
			switch (rs.getFetchDirection()) {
			case ResultSet.FETCH_FORWARD :
				System.out.println("FETCH_FORWARD");
				break;
			case ResultSet.FETCH_REVERSE :
				System.out.println("FETCH_REVERSE");
				break;
			case ResultSet.FETCH_UNKNOWN :
				System.out.println("FETCH_UNKNOWN");
				break;
			default :
				break;
			}
			System.out.println(rs.getFetchSize());
			while(rs.next()){
				rs.deleteRow();
			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
