package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class RSUpdateSample1 {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			// 更新可能なResultSetとする
			st = con.createStatement(
					ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE);
			ResultSet rs = st.executeQuery("SELECT name FROM user_list ORDER BY id");

			while (rs.next()) {
				String name = rs.getString("name");
				// namel列の内容を大文字に更新する
				rs.updateString("name", name.toUpperCase());
				rs.updateRow();
			}
			ResultSet rsa = st.executeQuery("SELECT * FROM user_list ORDER BY id");
			while (rsa.next()) {
				System.out.println(
						rsa.getString("id") + " " + rsa.getString("name"));
			}

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}

	}
}