package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class SQBatchSample {
	public static void main(String[] args) {
		// データの挿入と更新をまとめて行う
		Connection con = null;
		Statement stmt = null;

		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");
			stmt = con.createStatement();

			// 実行リストに追加（挿入と更新）
			stmt.addBatch("INSERT INTO user_list(id,name) VALUES (5,'Mayu Watanabe')");
			stmt.addBatch( "UPDATE user_list SET name='Minami Takahashi' WHERE id =5");

			// まとめて実行
			int[] ret = stmt.executeBatch();

			for ( int i : ret ) {
				System.out.printf("結果: %d\n",i);
			}

			System.out.println("\n実行後");
			ResultSet after = stmt.executeQuery("SELECT * FROM user_list ORDER BY id");
			while (after.next()) {
				System.out.printf("%s %s%n", after.getString("id"), after.getString("name").toString());
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}
