package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

public class SQExeSample {
	public static void main(String[] args) {
		// 3つの方法でSQL文を実行
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			Connection con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");
			Statement st = 
				con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
									ResultSet.CONCUR_UPDATABLE);

			// executeQueryを用いて単一の結果を返すようなSQL文の実行
			ResultSet rs1 = st.executeQuery("SELECT * FROM user_list");
			while (rs1.next()) {
				System.out.println(rs1.getInt("id") + " " + rs1.getString("name"));
			}

			// executeUpdateを用いて結果を返さないようなSQL文の実行
			int count = st.executeUpdate("INSERT INTO user_list(id,name) VALUES (10,'Tomomi Itano')");
			System.out.println(count + "件追加しました");

			// executeを用いて複数の結果を返す可能性のあるSQL文の実行
			boolean bl = st.execute("SELECT * FROM user_list");
			System.out.println(bl);
			count = st.getUpdateCount();
			ResultSet rs2 = st.getResultSet();
			if (count != -1) {
				System.out.println(count + "件更新しました");
			} else {
				while (rs2.next()) {
					System.out.println(rs2.getInt("id") + " " + rs2.getString("name"));
				}
			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}