package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class SQExeSample2 {
	public static void main(String[] args) {
		Connection con = null;
		Statement stmt = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			stmt = con.createStatement();

			// executeを用いて複数の結果を返す可能性のあるSQL文の実行
			boolean bl = stmt.execute("SELECT * FROM user_list");
			System.out.println("最初の結果セット: "+bl);

			// 更新行数の取得
			int count = stmt.getUpdateCount();
			if (count != -1) {
				System.out.println(count + "件更新しました");
			} else {
				// 結果セットの取得
				ResultSet rs = stmt.getResultSet();
				while (rs.next()) {
					System.out.println(rs.getInt("id") + " " + rs.getString("name"));
				}
				System.out.println( "次の結果セット: " + stmt.getMoreResults() );
			}
			
			System.out.println("");
	
			bl = stmt.execute("INSERT INTO user_list(id,name) VALUES (10,'Tomomi Itano')");
			System.out.println("最初の結果セット: "+bl);

			// 更新行数の取得
			count = stmt.getUpdateCount();
			if (count != -1) {
				System.out.println(count + "件更新しました");
			} else {
				// 結果セットの取得
				ResultSet rs = stmt.getResultSet();
				while (rs.next()) {
					System.out.println(rs.getInt("id") + " " + rs.getString("name"));
				}
				System.out.println( "次の結果セット: " + stmt.getMoreResults() );
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}