package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

public class SQExeSample3 {
	public static void main(String[] args) {
		Connection con = null;
		Statement stmt = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			stmt = con.createStatement();

			// executeUpdateを用いて結果を返さないようなSQL文の実行
			int count = stmt.executeUpdate("UPDATE user_list SET name='Minami Takahashi' WHERE id =10");
			System.out.println(count + "件追加しました");

		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}