package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class SQGetAboutRSSample1 {
	public static void main(String[] args) {
		Connection con = null;
		Statement stmt = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			stmt = con.createStatement();
			System.out.println("最大取得行数：" + stmt.getMaxRows());
			System.out.println("列のバイト数：" + stmt.getMaxFieldSize());

			stmt.execute("SELECT * FROM user_list");
			ResultSet rs = stmt.getResultSet();
			while (rs.next()) {
				System.out.println(
						rs.getInt("id") + " " + rs.getString("name"));
			}

			System.out.println();
			stmt.setMaxRows(2);
			stmt.setMaxFieldSize(5);
			System.out.println("最大取得行数：" + stmt.getMaxRows());
			System.out.println("列のバイト数：" + stmt.getMaxFieldSize());
			stmt.execute("SELECT * FROM user_list");

			ResultSet rs2 = stmt.getResultSet();
			while (rs2.next()) {
				System.out.println(
						rs2.getInt("id") + " " + rs2.getString("name"));
			}


		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}


	}
}