package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class SQParameterSample1 {
	public static void main(String[] args) {
		Connection con = null;
		PreparedStatement pst = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			pst =
				con.prepareStatement("SELECT * FROM user_list WHERE (id < ?) AND (name LIKE ?)");

			// IDが3より小さく、namaがAで始まるレコード
			pst.setInt(1,3);
			pst.setString(2,"A%");
			ResultSet rs = pst.executeQuery();
			while(rs.next()){
				System.out.println(rs.getInt("id") + " " + rs.getString("name"));
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (pst!=null ) pst.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}