package chap7;

import java.sql.Statement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class SQParameterSample2 {
	public static void main(String[] args) {
		Connection con = null;
		Statement st = null;
		PreparedStatement pst = null;

		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			// 接続処理
			con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			pst =
				con.prepareStatement("INSERT INTO user_list(id,name) VALUES((SELECT MAX(id) from USER_LIST)+1,?)");

			pst.setString(1,"Haruna Kojima");
			System.out.printf("%dレコード追加\n",pst.executeUpdate());

			pst.setNull(1,java.sql.Types.VARCHAR);
			System.out.printf("%dレコード追加\n",pst.executeUpdate());

			st = con.createStatement();
			ResultSet rs = st.executeQuery("SELECT * FROM user_list"); 

			while(rs.next()){
				System.out.println(rs.getInt("id") + " " + rs.getString("name"));
			}
		}
		catch (ClassNotFoundException e) {
			System.out.println("登録に失敗しました; "+e.getMessage());
		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (st!=null ) st.close();
			} catch (Exception e) {
			}
			try {
				if (pst!=null ) pst.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}
}