package chap7;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;

class SQStoreSetSample {
	public static void main(String[] args) {
		// ストアドプロシージャにパラメータを与えて実行
		try {
            Class.forName("oracle.jdbc.driver.OracleDriver");
            Connection con =
            	DriverManager.getConnection(
            			"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			// ストアドプロシージャの登録
            Statement st = con.createStatement();
			st.executeUpdate(
					"create or replace PROCEDURE OUTPARAMNAME (mid in NUMBER, vname out VARCHAR2) as" +
					" begin"+
					" SELECT name into vname FROM user_list WHERE id=mid;"+
					" end outParamName;");

			// ストアドプロシージャの呼び出し
			CallableStatement cs = con.prepareCall("{call OUTPARAMNAME(?,?)}");
			cs.setInt(1, 3); // 入力パラメータの設定
			cs.registerOutParameter(2, java.sql.Types.VARCHAR); // OUTパラメータの型を指定
			cs.execute();

			// OUTパラメータを取得
		    String out = cs.getString(2);
		    System.out.println(out);

			cs.close();
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}