package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class TRCommitRollbackSample {
	public static void main(String[] args) {
		// データを追加したとき、例外が発生したような場合に、
		// ロールバック処理を行う。実行結果なし。
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			Connection con =
				DriverManager.getConnection(
						"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");

			// オートコミットをしない
			con.setAutoCommit(false);
			Statement st = con.createStatement(
					ResultSet.TYPE_SCROLL_SENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			try {
				st.executeUpdate("INSERT INTO user_list(id,name) VALUES(3,'Haruna Kojima')");
				st.executeUpdate("INSERT INTO user_list(id,name) VALUES(4,'Mayu Watanabe')");
				con.commit(); //コミット
			}
			catch (SQLException e) {
				// 何らかのエラーが生じた場合にはロールバック
				con.rollback();
				System.out.println( "ロールバックしました");
				System.out.println( e.getMessage() );
			}
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
