package chap7;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class TRSetTransactionSample {

	Connection con = null;
	Statement stmt = null;

	class TRSetTransactionSampleThread1 extends Thread
	{
		public void run() {
			try {
				Thread.sleep(1000);

				new TRSetTransactionSample().delete();
				System.out.println("1件削除");

			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	public void delete()  throws InterruptedException {
		try {
			// 接続処理
			con = DriverManager.getConnection(
					"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");
			con.setAutoCommit(false);

			stmt = con.createStatement();
			// 先頭行を削除する
			stmt.execute("DELETE FROM user_list WHERE ROWNUM=1");
			con.commit();
		}
		catch (SQLException e) {
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}
	}

	public void test(int level) throws InterruptedException {
		try {

			Thread t1 = new TRSetTransactionSampleThread1();
			t1.start();

			con = DriverManager.getConnection(
					"jdbc:oracle:thin:@localhost:1521:xe","scott", "tiger");
			con.setAutoCommit(false);

			con.setTransactionIsolation(level);

			stmt = con.createStatement();

			for ( int i=0; i<5; i++) {
				ResultSet rs = stmt.executeQuery("SELECT count(*) FROM user_list");
				rs.next();
				System.out.println( "トランザクション中の件数:" + rs.getInt(1));
				rs.close();
				Thread.sleep(500);
			}

			t1.join();
			System.out.println("");

		}
		catch (SQLException e) {
			System.out.println("処理に失敗しました; "+e.getMessage());
		}
		finally {
			try {
				if (stmt!=null ) stmt.close();
			} catch (Exception e) {
			}
			try {
				// 切断処理
				if (con!=null ) con.close();
			} catch (Exception e) {
			}
		}

	}
	public static void main(String[] args) {
		try {
			// ドライバの登録
			Class.forName("oracle.jdbc.driver.OracleDriver");

			System.out.println("TRANSACTION_SERIALIZABLE");
			new TRSetTransactionSample().test(Connection.TRANSACTION_SERIALIZABLE);

			System.out.println("TRANSACTION_READ_COMMITTED");
			new TRSetTransactionSample().test(Connection.TRANSACTION_READ_COMMITTED);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
