package chap8;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class DeflateZIPFile{
	// chap8ディレクトリにあるzipSample1.txtを、ZIPファイルに圧縮
	public static void main(String[] args){

		byte[] buf = new byte[128];
		try{
			FileOutputStream fout = new FileOutputStream("chap8/defZipSample.zip");

			// ZIPデータの出力先をファイル出力ストリームを用いて指定
			ZipOutputStream zout = new ZipOutputStream(fout);
			String deflateFile = "chap8/zipSample1.txt";
			FileInputStream fin = new FileInputStream(deflateFile);
			BufferedInputStream bin = new BufferedInputStream(fin);

			// zipSample1.txtをZIPファイルのエントリに登録
			ZipEntry entry = new ZipEntry(deflateFile);
			zout.putNextEntry(entry);

			// bufにzipSample.txtの内容を読み込み、それをZIPファイルに書き込む
			int size;
			while((size = bin.read(buf, 0, buf.length)) != -1){
				zout.write(buf, 0, size);
			}
			System.out.println("書き込み終了");
			zout.closeEntry();  // エントリのクローズ
			bin.close();
			zout.flush();       // ストリームを閉じる。出力ストリームは
			zout.close();       // データをフラッシュしてから閉じる
		}
		catch(IOException e){
			e.printStackTrace();
		}
	}
}