package chap8;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class GZIPTypeSample {
	public static void main(String[] args) {
		// GZIP形式で圧縮し解凍
		byte[] buf = new byte[128];
		String data = "SAMPLE DATA";
		String gzfilename = "chap8/gzsample.gz";
		System.out.println("データ圧縮前:"+data);
		byte[] byteData = data.getBytes();
		try{
			// GZIP圧縮の出力先にファイル出力ストリームを指定し、データを書き込む
			FileOutputStream fout = new FileOutputStream(gzfilename);
			GZIPOutputStream gzout = new GZIPOutputStream(fout);
			gzout.write(byteData, 0, byteData.length);
			gzout.flush();
			gzout.close();  // データをフラッシュしてからストリームを閉じる

			// sample.gzファイルの中身を読み込み、文字列として格納
			FileInputStream fin = new FileInputStream(gzfilename);
			GZIPInputStream gzin = new GZIPInputStream(fin);
			gzin.read(buf, 0, buf.length);
			String inflatedData = new String(buf);
			System.out.println("データ解凍後:" + inflatedData);
			gzin.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
