package chap8;

import java.io.IOException;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class ReadZIPFile {
	public static void main(String[] args){
		try{
			ZipFile zip = new ZipFile("chap8/zipSample.zip");

			// エントリを列挙で取得
			Enumeration<? extends ZipEntry> entries = zip.entries();

			System.out.println("エントリの一覧");
			System.out.println("ファイル名:サイズ");

			// エントリの名前とサイズ、コメントを表示
			while(entries.hasMoreElements()){

				// エントリ名からZIPエントリを取得
				ZipEntry entry = zip.getEntry(entries.nextElement().toString());
				entry.setComment(entry.getName() + ":" + entry.getSize());
				System.out.println(entry.getComment());
			}
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
