package chap8;

import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

public class RecoveryFromJar{
	// chap8ディレクトリのsample2.jarからchap8/InflateZIPFile.javaを復元
	public static void main(String[] args){
		byte[] buf = new byte[128];
		String jarfilename = "chap8/sample2.jar";
		String entryname = "chap8/InflateZIPFile.java";
		try{
			JarFile jar = new JarFile(jarfilename);

			// JARファイルからエントリを取得し入力ストリームを取得する
			JarEntry entry = jar.getJarEntry(entryname);
			InputStream in = jar.getInputStream(entry);

			// 復元するファイルを作成
			FileOutputStream fout = new FileOutputStream(entryname);
			BufferedOutputStream bout = new BufferedOutputStream(fout);
			int size;
			while((size = in.read(buf, 0, buf.length)) != -1){
				bout.write(buf, 0, size);
			}
			System.out.println("復元完了");
			bout.flush();
			bout.close();
			in.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
