package chap8;

import java.util.Date;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

// 時刻表示、2秒待機、時刻表示する
class  WaitTask implements Runnable {
	public static int crlf =0;
	public void run(){
		System.out.print( "開始 " + new Date() + " ");
		if ( crlf==1 ) System.out.println("\n");
		try {
			Thread.sleep(2000); 		// 2秒待機
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println( "終了 " + new Date() );
	}
}

public class ScheduledExecutorSample {

	public static void main(String[] args) {

		ScheduledExecutorService ses =
			Executors.newSingleThreadScheduledExecutor();

		System.out.println("１回だけ実行");
		ses.schedule(new WaitTask(),0,TimeUnit.SECONDS);
		try{
			Thread.sleep(3000);  // 3秒待機
		}catch(InterruptedException e){
			System.out.println("This thread interrupted.");
		}
		ses.shutdown(); // タスクを終了させる

		System.out.println();
		ScheduledExecutorService ses2 =
			Executors.newSingleThreadScheduledExecutor();
		System.out.println("終了、開始の間隔が一定");

		WaitTask.crlf=1; // 改行追加
		// 3秒毎に実行
		ses2.scheduleWithFixedDelay(new WaitTask(),0, 3, TimeUnit.SECONDS);
		try{
			Thread.sleep(15000);  // 15秒待機
		}catch(InterruptedException e){
			System.out.println("This thread interrupted.");
		}
		ses2.shutdown(); // タスクを終了させる

		System.out.println();

		ScheduledExecutorService ses3 =
			Executors.newSingleThreadScheduledExecutor();
		System.out.println("実行開始が一定間隔");

		WaitTask.crlf=0;
		// 3秒毎に実行
		ses3.scheduleAtFixedRate(new WaitTask(),0, 3, TimeUnit.SECONDS);
		try{
			Thread.sleep(10000);  // 10秒待機
		}catch(InterruptedException e){
			System.out.println("This thread interrupted.");
		}
		ses3.shutdown(); // タスクを終了させる
	}

}
