package chap8;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.jar.JarEntry;
import java.util.jar.JarOutputStream;

// chap8ディレクトリにあるjarsample.txtをJARファイルに圧縮
public class WriteJarStream{
	public static void main(String[] args){
		byte[] buf = new byte[128];
		String jarfilename = "chap8/sample3.jar";
		String deflatefile = "chap8/jarsample1.txt";
		try{
			// 出力設定
			FileOutputStream fout = new FileOutputStream(jarfilename);
			JarOutputStream jout = new JarOutputStream(fout);

			// 入力設定
			FileInputStream fin = new FileInputStream(deflatefile);
			BufferedInputStream bin = new BufferedInputStream(fin);

			// JARファイルに格納するファイルと同じ名前のエントリを取得し、
			// ファイルの内容をJAR出力ストリームに書き込む
			JarEntry entry = new JarEntry(deflatefile);
			jout.putNextEntry(entry);
			int size;
			while((size = bin.read(buf, 0, buf.length)) != -1){
				jout.write(buf, 0, size);
			}
			System.out.println("書き込み完了");
			jout.closeEntry();
			bin.close();
			jout.flush();
			jout.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}