package chap8;

import java.util.zip.DataFormatException;
import java.util.zip.Deflater;
import java.util.zip.Inflater;

public class ZLIBInflateSample {
	public static void main(String[] args){
		// ZLIBライブラリを使用して、解凍を行います。

		String data = "DATA SAMPLE DATA SAMPLE DATA SAMPLE";
		byte[] byteData = data.getBytes();
		byte[] deflatedData = new byte[256];
		byte[] inflatedData = new byte[256];

		Deflater def = new Deflater();
		def.setInput(byteData);
		def.finish();
		def.deflate(deflatedData);	// 圧縮データをdeflatedDataに格納

		// 解凍するデータをバッファに登録
		Inflater inf = new Inflater();
		inf.setInput(deflatedData);
		if(inf.needsInput()){
			return;
		}
		try{
			// 解凍したデータをinflatedDataに格納
			inf.inflate(inflatedData);
			System.out.println("解凍したデータ:"+ new String(inflatedData));
			System.out.println("出力データサイズ:" + inf.getBytesWritten());
			System.out.println("入力データサイズ:" + inf.getBytesRead());
		}catch(DataFormatException e){
			e.printStackTrace();
		}
	}

}
